package be.iminds.ilabt.jfed.highlevel.util;

import be.iminds.ilabt.jfed.gui_preferences.JFedHLPreferences;
import be.iminds.ilabt.jfed.lowlevel.user.GeniUser;
import be.iminds.ilabt.jfed.lowlevel.user.GeniUserProvider;
import be.iminds.ilabt.jfed.ssh_terminal_tool.known_hosts.OpenSshKnownHostsFile;
import org.jetbrains.annotations.Nullable;

import javax.annotation.Nonnull;
import javax.inject.Inject;
import javax.inject.Singleton;

@Singleton
public class SshCommandBuilderFactory {
    @Nonnull private final GeniUserProvider geniUserProvider;
    @Nonnull private final JFedHLPreferences jFedPreferences;
    @Nonnull private final OpenSshKnownHostsFile openSshKnownHostsFile;

    @Inject
    public SshCommandBuilderFactory(@Nonnull GeniUserProvider geniUserProvider,
                                    @Nonnull JFedHLPreferences jFedPreferences,
                                    @Nonnull OpenSshKnownHostsFile openSshKnownHostsFile) {
        this.geniUserProvider = geniUserProvider;
        this.jFedPreferences = jFedPreferences;
        this.openSshKnownHostsFile = openSshKnownHostsFile;
    }

    public SshCommandBuilder create() {
        return new SshCommandBuilder(geniUserProvider, jFedPreferences, openSshKnownHostsFile, null);
    }

    public SshCommandBuilder create(@Nullable SshCommandBuilder.KeyPasswordRequester keyPasswordRequester) {
        return new SshCommandBuilder(geniUserProvider, jFedPreferences, openSshKnownHostsFile, keyPasswordRequester);
    }
}
